diff -uNrd ircd-ratbox-1.5-2/include/s_conf.h ircd-rb-FDF6.3a/include/s_conf.h
--- ircd-ratbox-1.5-2/include/s_conf.h	Wed Apr  7 16:37:45 2004
+++ ircd-rb-FDF6.3a/include/s_conf.h	Tue Jun  1 20:20:14 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_conf.h,v 7.241.2.15 2004/04/07 20:37:45 androsyn Exp $
+ *  $Id: s_conf.h,v 1.5 2004/06/02 00:20:14 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_conf_h
@@ -58,7 +58,6 @@
 
 extern FBFILE *conf_fbfile_in;
 extern char conf_line_in[256];
-extern struct ConfItem *yy_aconf;
 
 struct ConfItem
 {
@@ -105,6 +104,7 @@
 #define CONF_XLINE             0x40000
 #define CONF_ULINE             0x80000
 #define CONF_EXEMPTDLINE      0x100000
+#define CONF_SLINE            0x200000
 
 #define CONF_SERVER_MASK       CONF_SERVER
 #define CONF_CLIENT_MASK       (CONF_CLIENT | CONF_OPERATOR | CONF_SERVER_MASK)
@@ -115,7 +115,6 @@
 
 /* Generic flags... */
 /* access flags... */
-#define CONF_FLAGS_DO_IDENTD            0x00000001
 #define CONF_FLAGS_LIMIT_IP             0x00000002
 #define CONF_FLAGS_NO_TILDE             0x00000004
 #define CONF_FLAGS_NEED_IDENTD          0x00000008
@@ -153,7 +152,6 @@
 #define IsConfExemptFlood(x)    ((x)->flags & CONF_FLAGS_EXEMPTFLOOD)
 #define IsConfExemptSpambot(x)	((x)->flags & CONF_FLAGS_EXEMPTSPAMBOT)
 #define IsConfIdlelined(x)      ((x)->flags & CONF_FLAGS_IDLE_LINED)
-#define IsConfDoIdentd(x)       ((x)->flags & CONF_FLAGS_DO_IDENTD)
 #define IsConfDoSpoofIp(x)      ((x)->flags & CONF_FLAGS_SPOOF_IP)
 #define IsConfSpoofNotice(x)    ((x)->flags & CONF_FLAGS_SPOOF_NOTICE)
 #define IsConfRestricted(x)     ((x)->flags & CONF_FLAGS_RESTRICTED)
@@ -227,7 +225,6 @@
 	int pace_wait_simple;
 	int short_motd;
 	int no_oper_flood;
-	int glines;
 	int gline_time;
 	int gline_min_cidr;
 	int gline_min_cidr6;
@@ -256,7 +253,15 @@
 	int hidden_oper_confonly;
 	char default_operstring[REALLEN];
 	char default_adminstring[REALLEN];
-
+	int check_clone;
+	int check_clone_limit;
+	int check_clone_period;
+	int check_clone_delay;
+	char *inu_hack_passwd;
+	int inu_server_can_op;
+	int inu_ignore_bans;
+	int inu_serv_can_collide;
+	int jb_serv_can_kick;
 #ifdef IPV6
 	int fallback_to_ip6_int;
 #endif
@@ -281,7 +286,8 @@
 	int default_split_user_count;
 	int default_split_delay;
 	int no_oper_resvs;
-	int burst_topicwho;
+	int opers_see_hidden;
+	int opers_see_topic;
 };
 
 struct config_server_hide
@@ -331,6 +337,8 @@
 /* conf xline link list root */
 extern struct ConfItem *x_conf;
 extern struct ConfItem *x_temp_conf;
+/* conf xline link list root */
+extern struct ConfItem *s_conf;
 
 /* All variables are GLOBAL */
 extern struct ConfItem *ConfigItemList;	/* conf list head */
@@ -385,6 +393,7 @@
 extern int find_u_conf(char *, char *, char *, int);
 extern struct ConfItem *find_x_conf(const char *);
 extern struct ConfItem *find_x_conf_exact(const char *);
+extern int IsSLine(const struct Client *client_p);
 
 extern struct ConfItem *find_tkline(const char *, const char *, struct irc_inaddr *);
 extern char *show_iline_prefix(struct Client *, struct ConfItem *, char *);
@@ -427,6 +436,7 @@
 extern void conf_add_me(struct ConfItem *);
 extern void conf_add_class(struct ConfItem *, int);
 extern void conf_add_d_conf(struct ConfItem *);
+extern void conf_add_s_conf(struct ConfItem *);
 extern void conf_add_x_conf(struct ConfItem *);
 extern void conf_add_u_conf(struct ConfItem *);
 extern void conf_add_fields(struct ConfItem *, const char *, const char *, 
diff -uNrd ircd-ratbox-1.5-2/include/s_debug.h ircd-rb-FDF6.3a/include/s_debug.h
--- ircd-ratbox-1.5-2/include/s_debug.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/s_debug.h	Thu Apr  1 15:45:58 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_debug.h,v 7.8.4.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: s_debug.h,v 1.1.1.2 2004/04/01 20:45:58 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_debug_h
diff -uNrd ircd-ratbox-1.5-2/include/s_gline.h ircd-rb-FDF6.3a/include/s_gline.h
--- ircd-ratbox-1.5-2/include/s_gline.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/s_gline.h	Thu Apr  1 16:20:48 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_gline.h,v 7.16.4.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: s_gline.h,v 1.3 2004/04/01 21:20:48 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_gline_h
@@ -46,13 +46,6 @@
 	const char *oper_server1;	/* point to scache */
 	char *reason1;
 	time_t time_request1;
-
-	char oper_nick2[NICKLEN + 1];
-	char oper_user2[USERLEN + 1];
-	char oper_host2[HOSTLEN + 1];
-	const char *oper_server2;	/* point to scache */
-	char *reason2;
-	time_t time_request2;
 
 	time_t last_gline_time;	/* for expiring entry */
 	char user[USERLEN + 1];
diff -uNrd ircd-ratbox-1.5-2/include/s_log.h ircd-rb-FDF6.3a/include/s_log.h
--- ircd-ratbox-1.5-2/include/s_log.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/s_log.h	Thu Apr  1 15:45:58 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_log.h,v 7.19.2.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: s_log.h,v 1.1.1.2 2004/04/01 20:45:58 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_log_h
diff -uNrd ircd-ratbox-1.5-2/include/s_misc.h ircd-rb-FDF6.3a/include/s_misc.h
--- ircd-ratbox-1.5-2/include/s_misc.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/s_misc.h	Thu Apr  1 15:45:58 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_misc.h,v 7.9.2.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: s_misc.h,v 1.1.1.2 2004/04/01 20:45:58 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_misc_h
diff -uNrd ircd-ratbox-1.5-2/include/s_serv.h ircd-rb-FDF6.3a/include/s_serv.h
--- ircd-ratbox-1.5-2/include/s_serv.h	Sun Apr 11 22:08:13 2004
+++ ircd-rb-FDF6.3a/include/s_serv.h	Sat Jun 19 22:45:53 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_serv.h,v 7.80.2.6 2004/04/12 02:08:13 leeh Exp $
+ *  $Id: s_serv.h,v 1.5 2004/04/14 16:01:14 jailbird Exp $
  */
 
 #ifndef INCLUDED_serv_h
@@ -58,6 +58,7 @@
 
 #define CAP_CAP         0x00000001	/* received a CAP to begin with */
 #define CAP_QS          0x00000002	/* Can handle quit storm removal */
+#define CAP_FDF		0x00000004	/* Can handle FDFnet extensions */
 #define CAP_EX          0x00000008	/* Can do channel +e exemptions */
 #define CAP_CHW         0x00000010	/* Can do channel wall @# */
 #define CAP_IE          0x00000040	/* Can do invite exceptions */
@@ -77,7 +78,7 @@
                          CAP_IE  | CAP_KLN  | \
                          CAP_GLN | CAP_CLUSTER | CAP_ENCAP | \
                          CAP_ZIP  | CAP_ENC | \
-                         CAP_KNOCK  | CAP_UNKLN)
+                         CAP_KNOCK  | CAP_UNKLN | CAP_FDF)
 
 #ifdef HAVE_LIBZ
 #define CAP_ZIP_SUPPORTED       CAP_ZIP
diff -uNrd ircd-ratbox-1.5-2/include/s_stats.h ircd-rb-FDF6.3a/include/s_stats.h
--- ircd-ratbox-1.5-2/include/s_stats.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/s_stats.h	Thu Apr  1 15:45:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_stats.h,v 7.13.4.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: s_stats.h,v 1.1.1.2 2004/04/01 20:45:59 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_stats_h
diff -uNrd ircd-ratbox-1.5-2/include/s_user.h ircd-rb-FDF6.3a/include/s_user.h
--- ircd-ratbox-1.5-2/include/s_user.h	Sun Mar 28 06:45:14 2004
+++ ircd-rb-FDF6.3a/include/s_user.h	Thu Apr  1 15:45:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_user.h,v 7.24.2.6 2004/03/28 11:45:14 leeh Exp $
+ *  $Id: s_user.h,v 1.1.1.2 2004/04/01 20:45:59 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_user_h
diff -uNrd ircd-ratbox-1.5-2/include/s_zip.h ircd-rb-FDF6.3a/include/s_zip.h
--- ircd-ratbox-1.5-2/include/s_zip.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/s_zip.h	Thu Apr  1 15:45:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_zip.h,v 7.9.4.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: s_zip.h,v 1.1.1.2 2004/04/01 20:45:59 jailbird Exp $
  */
 
 #ifndef INCLUDED_s_zip_h
diff -uNrd ircd-ratbox-1.5-2/include/scache.h ircd-rb-FDF6.3a/include/scache.h
--- ircd-ratbox-1.5-2/include/scache.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/scache.h	Thu Apr  1 15:45:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: scache.h,v 7.12.4.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: scache.h,v 1.1.1.2 2004/04/01 20:45:59 jailbird Exp $
  */
 
 #ifndef INCLUDED_scache_h
diff -uNrd ircd-ratbox-1.5-2/include/send.h ircd-rb-FDF6.3a/include/send.h
--- ircd-ratbox-1.5-2/include/send.h	Sun Apr  4 20:29:40 2004
+++ ircd-rb-FDF6.3a/include/send.h	Sat Apr 10 18:44:49 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: send.h,v 7.71.2.4 2004/04/05 00:29:40 leeh Exp $
+ *  $Id: send.h,v 1.1.1.3 2004/04/10 22:44:49 jailbird Exp $
  */
 
 #ifndef INCLUDED_send_h
diff -uNrd ircd-ratbox-1.5-2/include/serno.h ircd-rb-FDF6.3a/include/serno.h
--- ircd-ratbox-1.5-2/include/serno.h	Thu Jun 17 14:01:50 2004
+++ ircd-rb-FDF6.3a/include/serno.h	Thu Jun 17 18:20:43 2004
@@ -1 +1 @@
-#define SERIALNUM "20040617_3"
+#define SERIALNUM "20040617_4"
diff -uNrd ircd-ratbox-1.5-2/include/setup.h_vms ircd-rb-FDF6.3a/include/setup.h_vms
--- ircd-ratbox-1.5-2/include/setup.h_vms	Thu Jun 26 10:01:42 2003
+++ ircd-rb-FDF6.3a/include/setup.h_vms	Mon Jan 19 22:26:02 2004
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: setup.h_vms,v 7.13.2.1 2003/06/26 14:01:42 androsyn Exp $
+ *  $Id: setup.h_vms,v 1.1.1.1 2004/01/20 03:26:02 jailbird Exp $
  */
 
 /* include/setup.h.in.  Generated automatically from autoconf/configure.in by autoheader.  */
diff -uNrd ircd-ratbox-1.5-2/include/sprintf_irc.h ircd-rb-FDF6.3a/include/sprintf_irc.h
--- ircd-ratbox-1.5-2/include/sprintf_irc.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/sprintf_irc.h	Thu Apr  1 15:45:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: sprintf_irc.h,v 7.13.4.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: sprintf_irc.h,v 1.1.1.2 2004/04/01 20:45:59 jailbird Exp $
  */
 
 #ifndef SPRINTF_IRC
diff -uNrd ircd-ratbox-1.5-2/include/stdinc.h ircd-rb-FDF6.3a/include/stdinc.h
--- ircd-ratbox-1.5-2/include/stdinc.h	Wed Oct 15 12:33:59 2003
+++ ircd-rb-FDF6.3a/include/stdinc.h	Mon Jan 19 22:26:02 2004
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- * $Id: stdinc.h,v 1.10.2.2 2003/10/15 16:33:59 androsyn Exp $
+ * $Id: stdinc.h,v 1.1.1.1 2004/01/20 03:26:02 jailbird Exp $
  *
  */
 
diff -uNrd ircd-ratbox-1.5-2/include/supported.h ircd-rb-FDF6.3a/include/supported.h
--- ircd-ratbox-1.5-2/include/supported.h	Wed Apr 21 11:07:13 2004
+++ ircd-rb-FDF6.3a/include/supported.h	Wed Apr 21 22:10:45 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: supported.h,v 1.31.2.6 2004/04/21 15:07:13 leeh Exp $
+ *  $Id: supported.h,v 1.6 2004/04/22 02:10:45 jailbird Exp $
  */
 
 #ifndef INCLUDED_supported_h
@@ -31,11 +31,7 @@
 #include "channel.h"
 #include "ircd_defs.h"
 
-#ifndef USE_ASCII_CASEMAP
 #define CASEMAP "rfc1459"
-#else
-#define CASEMAP "ascii"
-#endif
 
 #define FEATURES "STD=i-d" \
 		" STATUSMSG=@+" \
@@ -57,7 +53,7 @@
 
 #define FEATURES2 "CHANTYPES=%s" \
                   " PREFIX=(ov)@+" \
-		  " CHANMODES=%s%sb,k,l,imnpst" \
+		  " CHANMODES=%s%sb,k,l,cimnpst" \
 		  " NETWORK=%s" \
 		  " CASEMAPPING=%s" \
 		  " CHARSET=ascii" \
diff -uNrd ircd-ratbox-1.5-2/include/tools.h ircd-rb-FDF6.3a/include/tools.h
--- ircd-ratbox-1.5-2/include/tools.h	Wed May 19 19:19:29 2004
+++ ircd-rb-FDF6.3a/include/tools.h	Mon May 31 00:02:21 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: tools.h,v 1.45.2.4 2004/05/19 23:19:29 leeh Exp $
+ *  $Id: tools.h,v 1.3 2004/05/31 04:02:21 jailbird Exp $
  */
 
 #ifndef __TOOLS_H__
diff -uNrd ircd-ratbox-1.5-2/include/whowas.h ircd-rb-FDF6.3a/include/whowas.h
--- ircd-ratbox-1.5-2/include/whowas.h	Mon Mar 15 13:19:45 2004
+++ ircd-rb-FDF6.3a/include/whowas.h	Thu Apr  1 15:45:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: whowas.h,v 7.15.2.2 2004/03/15 18:19:45 leeh Exp $
+ *  $Id: whowas.h,v 1.1.1.2 2004/04/01 20:45:59 jailbird Exp $
  */
 #ifndef INCLUDED_whowas_h
 #define INCLUDED_whowas_h
diff -uNrd ircd-ratbox-1.5-2/make.com ircd-rb-FDF6.3a/make.com
--- ircd-ratbox-1.5-2/make.com	Thu Nov 21 16:18:19 2002
+++ ircd-rb-FDF6.3a/make.com	Mon Jan 19 22:25:59 2004
@@ -1,7 +1,7 @@
 $ WRITE SYS$OUTPUT "Commencing build of ircd-ratbox for VMS..."
 $ WRITE SYS$OUTPUT "Examining source directory..."
 $
-$! $Id: make.com,v 1.8 2002/11/21 21:18:19 leeh Exp $
+$! $Id: make.com,v 1.1.1.1 2004/01/20 03:25:59 jailbird Exp $
 $! Don't have to do this any more - we now depend on
 $! bison/flex to build.
 $! FILE_SIZE = "NOSUCHFILE"
diff -uNrd ircd-ratbox-1.5-2/messages/.cvsignore ircd-rb-FDF6.3a/messages/.cvsignore
--- ircd-ratbox-1.5-2/messages/.cvsignore	Sat Jun 28 05:22:58 2003
+++ ircd-rb-FDF6.3a/messages/.cvsignore	Mon Feb  9 17:22:57 2004
@@ -1,2 +1,3 @@
-*.mo
 Makefile
+ayb.mo
+custom.mo
diff -uNrd ircd-ratbox-1.5-2/messages/build_one ircd-rb-FDF6.3a/messages/build_one
--- ircd-ratbox-1.5-2/messages/build_one	Thu Jun 26 10:51:18 2003
+++ ircd-rb-FDF6.3a/messages/build_one	Mon Jan 19 22:26:02 2004
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-# $Id: build_one,v 1.3.2.1 2003/06/26 14:51:18 androsyn Exp $
+# $Id: build_one,v 1.1.1.1 2004/01/20 03:26:02 jailbird Exp $
 # 
 # This is a script to build a single message file based on the variables
 # in Makefile (yes, this means that configure MUST have been run
diff -uNrd ircd-ratbox-1.5-2/messages/create_po ircd-rb-FDF6.3a/messages/create_po
--- ircd-ratbox-1.5-2/messages/create_po	Thu Jun 26 10:51:18 2003
+++ ircd-rb-FDF6.3a/messages/create_po	Mon Jan 19 22:26:02 2004
@@ -1,5 +1,5 @@
 #!/bin/sh
-# $Id: create_po,v 1.2.2.1 2003/06/26 14:51:18 androsyn Exp $
+# $Id: create_po,v 1.1.1.1 2004/01/20 03:26:02 jailbird Exp $
 i=$1
 
 if [ "x$i" = "x" ]; then
diff -uNrd ircd-ratbox-1.5-2/messages/translations/.cvsignore ircd-rb-FDF6.3a/messages/translations/.cvsignore
--- ircd-ratbox-1.5-2/messages/translations/.cvsignore	Sat Jun 28 08:19:18 2003
+++ ircd-rb-FDF6.3a/messages/translations/.cvsignore	Mon Feb  9 17:22:57 2004
@@ -1,2 +1 @@
-*.mo
 Makefile
diff -uNrd ircd-ratbox-1.5-2/messages/translations/README ircd-rb-FDF6.3a/messages/translations/README
--- ircd-ratbox-1.5-2/messages/translations/README	Thu Jun 26 10:51:24 2003
+++ ircd-rb-FDF6.3a/messages/translations/README	Mon Jan 19 22:26:02 2004
@@ -38,4 +38,4 @@
 to ircd-hybrid@the-project.org, hybrid@the-project.org, or directly to one
 of the people who work with the translations, currently wcampbel@botbay.net.
 
-$Id: README,v 1.9.2.1 2003/06/26 14:51:24 androsyn Exp $
\ No newline at end of file
+$Id: README,v 1.1.1.1 2004/01/20 03:26:02 jailbird Exp $
\ No newline at end of file
diff -uNrd ircd-ratbox-1.5-2/modules/.cvsignore ircd-rb-FDF6.3a/modules/.cvsignore
--- ircd-ratbox-1.5-2/modules/.cvsignore	Thu Jun 26 10:02:11 2003
+++ ircd-rb-FDF6.3a/modules/.cvsignore	Tue Jun  1 19:57:12 2004
@@ -1 +1,5 @@
+!
+. .. RCSLOG tags TAGS RCS SCCS .make.state
+.nse_depinfo #* .#* cvslog.* ,* CVS CVS.adm .del-* *.a *.olb *.o *.obj
+ *.so *.Z *~ *.old *.elc *.ln *.bak *.BAK *.orig *.rej *.exe _$* *$
 Makefile
diff -uNrd ircd-ratbox-1.5-2/modules/core/descrip.mms ircd-rb-FDF6.3a/modules/core/descrip.mms
--- ircd-ratbox-1.5-2/modules/core/descrip.mms	Thu Jun 26 10:02:37 2003
+++ ircd-rb-FDF6.3a/modules/core/descrip.mms	Tue Jun  1 12:28:41 2004
@@ -1,6 +1,6 @@
 # MMS/MMK Makefile for OpenVMS
 # Copyright (c) 2001 Edward Brocklesby
-# $Id: descrip.mms,v 1.2.2.1 2003/06/26 14:02:37 androsyn Exp $
+# $Id: descrip.mms,v 1.3 2004/06/01 16:28:41 jailbird Exp $
 
 CC=	CC
 CFLAGS=	/INCLUDE_DIRECTORY=([-.-.INCLUDE],[-.-.ADNS])/STANDARD=ISOC94
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_die.c ircd-rb-FDF6.3a/modules/core/m_die.c
--- ircd-ratbox-1.5-2/modules/core/m_die.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_die.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_die.c,v 1.37.2.3 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_die.c,v 1.3 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -59,7 +59,7 @@
 	mod_del_cmd(&die_msgtab);
 }
 
-const char *_version = "$Revision: 1.37.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_die - DIE command handler
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_kick.c ircd-rb-FDF6.3a/modules/core/m_kick.c
--- ircd-ratbox-1.5-2/modules/core/m_kick.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_kick.c	Thu Jun 17 13:09:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_kick.c,v 1.68.2.4 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_kick.c,v 1.7 2004/06/17 17:09:59 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -39,7 +39,7 @@
 #include "parse.h"
 #include "hash.h"
 #include "packet.h"
-
+#include "s_conf.h"
 
 static void m_kick(struct Client *, struct Client *, int, char **);
 static void ms_kick(struct Client *, struct Client *, int, char **);
@@ -61,7 +61,7 @@
 	mod_del_cmd(&kick_msgtab);
 }
 
-const char *_version = "$Revision: 1.68.2.4 $";
+const char *_version = "$Revision: 1.7 $";
 #endif
 /*
 ** m_kick
@@ -77,6 +77,7 @@
 	struct Channel *chptr;
 	struct membership *msptr;
 	int chasing = 0;
+	int can_kick = 0;
 	char *comment;
 	char *name;
 	char *p = (char *) NULL;
@@ -109,7 +110,7 @@
 		return;
 	}
 
-	if(!IsServer(source_p))
+	if(!IsServer(source_p) && !IsSLine(source_p))
 	{
 		msptr = find_channel_membership(chptr, source_p);
 
@@ -120,7 +121,14 @@
 			return;
 		}
 
-		if(!is_chanop(msptr))
+		/* Okay. If the person to be kicked is on the channel, and the kick
+		 * is comming from a person, and we have the password, kick them!
+		 * -JailBird */
+		if (ConfigFileEntry.jb_serv_can_kick &&
+		    !strcmp(ConfigFileEntry.inu_hack_passwd, comment))
+			can_kick = 1;
+
+		if(!is_chanop(msptr) && !can_kick)
 		{
 			if(MyConnect(source_p))
 			{
@@ -174,6 +182,8 @@
 	msptr = find_channel_membership(chptr, who);
 	if(msptr != NULL)
 	{
+		if (is_safe(msptr)&&!IsServer(source_p)&&!IsSLine(source_p))
+			return;
 		/* jdc
 		 * - In the case of a server kicking a user (i.e. CLEARCHAN),
 		 *   the kick should show up as coming from the server which did
@@ -181,6 +191,13 @@
 		 * - Personally, flame and I believe that server kicks shouldn't
 		 *   be sent anyways.  Just waiting for some oper to abuse it...
 		 */
+		if (can_kick) /* Rewrite comment and send notice. -JailBird */
+		{
+			comment = me.name;
+			sendto_realops_flags(UMODE_ALL, L_ALL,
+					     "HACK: ServerKick by %s for %s on %s",
+					     source_p->name, who->name, name);
+		}
 		if(IsServer(source_p))
 		{
 			sendto_channel_local(ALL_MEMBERS, chptr, ":%s KICK %s %s :%s",
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_kill.c ircd-rb-FDF6.3a/modules/core/m_kill.c
--- ircd-ratbox-1.5-2/modules/core/m_kill.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_kill.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_kill.c,v 1.82.2.9 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_kill.c,v 1.9 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -67,7 +67,7 @@
 	mod_del_cmd(&kill_msgtab);
 }
 
-const char *_version = "$Revision: 1.82.2.9 $";
+const char *_version = "$Revision: 1.9 $";
 #endif
 /*
 ** mo_kill
@@ -83,6 +83,7 @@
 	char *user;
 	static char noreason[] = "<No reason given>";
 	const char *reason;
+	int sline;
 
 	user = parv[1];
 	reason = parv[2];	/* Either defined or NULL (parc >= 2!!) */
@@ -129,19 +130,44 @@
 		return;
 	}
 
-	if(MyConnect(target_p))
-		sendto_one(target_p, ":%s!%s@%s KILL %s :%s",
-			   source_p->name, source_p->username, source_p->host,
-			   target_p->name, reason);
+	/*****************************************************
+	* If the kill reason is the INU_HACK_PASSWD, perform *
+	* a nick collision kill by sending on a NICK message *
+	* to all our up/downlinks. Then return. - inubus     *
+	*****************************************************/
+	if (ConfigFileEntry.inu_serv_can_collide &&
+	    !strcmp(reason, ConfigFileEntry.inu_hack_passwd)) {
+		sendto_server(NULL, NULL, NOCAPS, NOCAPS,
+			     "NICK %s 1 1 + server collide.com %s :Collider",
+			     target_p->name, me.name);
+		sendto_server(NULL, NULL, NOCAPS, NOCAPS,
+			      ":%s QUIT :Collider", target_p->name);
+		sendto_realops_flags(UMODE_ALL, L_ALL, "HACK: ServerCollide by %s for %s",
+				     source_p->name, target_p->name);
+		return;
+	}
+
+	sline = IsSLine(source_p);
+
+	if(MyConnect(target_p)) {
+		if (sline)
+			sendto_one(target_p, ":%s KILL %s :%s",
+				   me.name, target_p->name, reason);
+		else
+			sendto_one(target_p, ":%s!%s@%s KILL %s :%s",
+				   source_p->name, source_p->username, source_p->host,
+				   target_p->name, reason);
+	}
 
 	/* Do not change the format of this message.  There's no point in changing messages
 	 * that have been around for ever, for no reason.. */
-	sendto_realops_flags(UMODE_ALL, L_ALL,
-			     "Received KILL message for %s. From %s Path: %s (%s)",
-			     target_p->name, parv[0], me.name, reason);
-
-	ilog(L_INFO, "KILL From %s For %s Path %s (%s)", parv[0], target_p->name, me.name, reason);
+	if (!sline) {
+		sendto_realops_flags(UMODE_ALL, L_ALL,
+				     "Received KILL message for %s. From %s Path: %s (%s)",
+				     target_p->name, parv[0], me.name, reason);
 
+		ilog(L_INFO, "KILL From %s For %s Path %s (%s)", parv[0], target_p->name, me.name, reason);
+	}
 
 	/*
 	 ** And pass on the message to other servers. Note, that if KILL
@@ -160,6 +186,11 @@
 		target_p->flags |= FLAGS_KILLED;
 	}
 
+	if (sline) {
+		exit_client(client_p, target_p, source_p, reason);
+		return;
+	}
+
 	ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
 
 	exit_client(client_p, target_p, source_p, buf);
@@ -180,6 +211,7 @@
 	char *reason;
 	char *path;
 	int chasing = 0;
+	int sline;
 
 	*buf = '\0';
 
@@ -236,12 +268,14 @@
 		return;
 	}
 
+	sline = IsSLine(source_p);
+
 	if(MyConnect(target_p))
 	{
-		if(IsServer(source_p))
+		if(IsServer(source_p)||sline)
 		{
 			/* dont send clients kills from a hidden server */
-			if(ConfigServerHide.hide_servers && !IsOper(target_p))
+			if((ConfigServerHide.hide_servers && !IsOper(target_p))||sline)
 				sendto_one(target_p, ":%s KILL %s :%s",
 					   me.name, target_p->name, reason);
 			else
@@ -259,27 +293,34 @@
 	/* path must contain at least 2 !'s, or bitchx falsely declares it
 	 * local --fl
 	 */
-	if(IsOper(source_p))	/* send it normally */
-	{
-		sendto_realops_flags(UMODE_ALL, L_ALL,
-				      "Received KILL message for %s. From %s Path: %s!%s!%s!%s %s",
-				      target_p->name, parv[0], source_p->user->server,
-				      source_p->host, source_p->username, source_p->name,
-				      reason);
-	}
-	else
-	{
-		sendto_realops_flags(UMODE_SKILL, L_ALL,
-				     "Received KILL message for %s. From %s %s",
-				     target_p->name, parv[0], reason);
+	if (!sline) {
+		if(IsOper(source_p))	/* send it normally */
+		{
+			sendto_realops_flags(UMODE_ALL, L_ALL,
+					      "Received KILL message for %s. From %s Path: %s!%s!%s!%s %s",
+					      target_p->name, parv[0], source_p->user->server,
+					      source_p->host, source_p->username, source_p->name,
+					      reason);
+		}
+		else
+		{
+			sendto_realops_flags(UMODE_SKILL, L_ALL,
+					     "Received KILL message for %s. From %s %s",
+					     target_p->name, parv[0], reason);
+		}
+	
+		ilog(L_INFO, "KILL From %s For %s Path %s %s", parv[0], target_p->name, parv[0], reason);
 	}
 
-	ilog(L_INFO, "KILL From %s For %s Path %s %s", parv[0], target_p->name, parv[0], reason);
-
 	relay_kill(client_p, source_p, target_p, path, reason);
 
 	/* FLAGS_KILLED prevents a quit being sent out */
 	target_p->flags |= FLAGS_KILLED;
+
+	if (sline) {
+		exit_client(client_p, target_p, source_p, reason);
+		return;
+	}
 
 	/* reason comes supplied with its own ()'s */
 	if(ConfigServerHide.hide_servers && IsServer(source_p))
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_message.c ircd-rb-FDF6.3a/modules/core/m_message.c
--- ircd-ratbox-1.5-2/modules/core/m_message.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_message.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_message.c,v 1.131.2.7 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_message.c,v 1.6 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -76,6 +76,7 @@
 
 static void m_privmsg(struct Client *, struct Client *, int, char **);
 static void m_notice(struct Client *, struct Client *, int, char **);
+static int msg_has_colors(const char *msg);
 
 static void msg_channel(int p_or_n, const char *command,
 			struct Client *client_p,
@@ -119,7 +120,7 @@
 	mod_del_cmd(&notice_msgtab);
 }
 
-const char *_version = "$Revision: 1.131.2.7 $";
+const char *_version = "$Revision: 1.6 $";
 #endif
 
 /*
@@ -414,6 +415,24 @@
 	return NO;
 }
 
+static int
+msg_has_colors(const char *msg)
+{
+	char const *c = msg;
+
+	while (*c)
+	{
+		if (*c == '\003' || *c == '\033')
+			break;
+		else
+			c++;
+	}
+
+	if (*c)
+		return 1;
+	return 0;
+}
+
 /*
  * msg_channel
  *
@@ -441,6 +460,12 @@
 	/* chanops and voiced can flood their own channel with impunity */
 	if((result = can_send(chptr, source_p, NULL)))
 	{
+		if (MyClient(source_p) && (chptr->mode.mode & MODE_NOCOLOR) &&
+		    msg_has_colors(text)) {
+			sendto_one(source_p, form_str(ERR_NOCOLORSONCHAN),
+				   me.name, source_p->name, chptr->chname);
+			return;
+		}
 		if(result == CAN_SEND_OPV ||
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
 		{
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_mode.c ircd-rb-FDF6.3a/modules/core/m_mode.c
--- ircd-ratbox-1.5-2/modules/core/m_mode.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_mode.c	Thu Jun 17 13:09:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_mode.c,v 1.73.2.4 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_mode.c,v 1.9 2004/06/17 17:09:59 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -66,7 +66,7 @@
 }
 
 
-const char *_version = "$Revision: 1.73.2.4 $";
+const char *_version = "$Revision: 1.9 $";
 #endif
 
 static void
@@ -88,6 +88,8 @@
 		*mbuf++ = 'i';
 	if(chptr->mode.mode & MODE_NOPRIVMSGS)
 		*mbuf++ = 'n';
+	if(chptr->mode.mode & MODE_NOCOLOR)
+		*mbuf++ = 'c';
 
 	if(chptr->mode.limit)
 	{
@@ -184,6 +186,25 @@
 	else
 	{
 		msptr = find_channel_membership(chptr, source_p);
+
+		/**********************************************************************
+		* Take the INU_HACK_PASSWD from where we put it earlier as indication *
+		* that this is a server op. Check if a server name was givem to seem  *
+		* to give the op. If not, use our name. Then op them. =) - inubus     *
+		**********************************************************************/
+		if (msptr != NULL && ConfigFileEntry.inu_server_can_op && parv[2] != NULL &&
+		    !strcmp(ConfigFileEntry.inu_hack_passwd, parv[2]))
+		{
+			change_channel_membership(msptr, CHFL_CHANOP, CHFL_DEOPPED);
+			sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +o %s", me.name,
+					     chptr->chname, source_p->name);
+			sendto_server(NULL, NULL, NOCAPS, NOCAPS,
+				      ":%s MODE %s +o %s", me.name, chptr->chname,
+				      source_p->name);
+			sendto_realops_flags(UMODE_ALL, L_ALL, "HACK: ServerOps hack in %s by %s",
+					     chptr->chname, source_p->name);
+			return;
+		}
 
 		if(is_deop(msptr))
 			return;
